#ifndef EQUIS_IMAGE_PIXEL_HPP
#define EQUIS_IMAGE_PIXEL_HPP

EQUIS_ENTER_NS2(equis,image);

struct PixelA8R8G8B8 {
	uint8 b;
	uint8 g;
	uint8 r;
	uint8 a;
};

struct PixelR8G8B8 {
	uint8 b;
	uint8 g;
	uint8 r;
};

struct PixelY8 {
	uint8 y;
};

struct PixelY16 {
	uint16 y;
};

struct PixelY8U8V8 {
	uint8 y;
	uint8 u;
	uint8 v;
};

template < typename Dst, typename Src > inline
void convertPixel(Dst& dst, const Src& src);

EQUIS_LEAVE_NS2(equis,image);

#define IN_EQUIS_IMAGE_PIXEL_HPP
#include "pixel.inl"
#undef IN_EQUIS_IMAGE_PIXEL_HPP

#endif /* EQUIS_IMAGE_PIXEL_HPP */
