#ifndef IN_EQUIS_WIN32_MEDIATYPE_HPP
#error This file must be included via MediaType.hpp
#endif /* IN_EQUIS_WIN32_MEDIATYPE_HPP */

EQUIS_ENTER_NS1(equis);

inline
MediaTypePtr::MediaTypePtr()
	: m_ptr(NULL), m_noRelease(false)
{}

inline
MediaTypePtr::~MediaTypePtr() {
	Clear();
}

inline bool
MediaTypePtr::IsNull() const {
	return m_ptr == NULL;
}

inline bool
MediaTypePtr::IsNotNull() const {
	return m_ptr != NULL;
}

inline AM_MEDIA_TYPE*
MediaTypePtr::operator -> () {
	EQUIS_DEBUG_ASSERT(m_ptr != NULL);
	return m_ptr;
}

inline const AM_MEDIA_TYPE*
MediaTypePtr::operator -> () const {
	EQUIS_DEBUG_ASSERT(m_ptr != NULL);
	return m_ptr;
}

inline 
MediaTypePtr::operator AM_MEDIA_TYPE* () {
	return m_ptr;
}

inline 
MediaTypePtr::operator const AM_MEDIA_TYPE* () const {
	return m_ptr;
}

inline void
MediaTypePtr::Set(AM_MEDIA_TYPE* ptr) {
	Clear();
	m_ptr = ptr;
}

inline void
MediaTypePtr::SetWithoutRelease(AM_MEDIA_TYPE* ptr) {
	m_ptr = ptr;
	m_noRelease = true;
}

inline AM_MEDIA_TYPE*
MediaTypePtr::ClearWithoutRelease() {
	AM_MEDIA_TYPE* ptr = m_ptr;
	m_ptr = NULL;
	m_noRelease = false;
	return ptr;
}

inline AM_MEDIA_TYPE**
MediaTypePtr::ClearAndGetPointer() {
	Clear();
	return &m_ptr;
}

EQUIS_LEAVE_NS1(equis);
