#ifndef EQUIS_WIN32_MUTEX_HPP
#define EQUIS_WIN32_MUTEX_HPP

EQUIS_ENTER_NS1(equis);

class Mutex
{
    EQUIS_NO_COPY(Mutex);
public:
    Mutex(HRESULT& res);
    virtual ~Mutex();

    HRESULT Enter(DWORD timeoutMs);
    HRESULT Leave();

	HANDLE GetHandle() { return m_handle; }

private:
    HANDLE m_handle;
};

class MutexLock
{
    EQUIS_NO_COPY(MutexLock)
public:
    MutexLock(Mutex *parent);
    ~MutexLock();

    HRESULT Enter(DWORD timeoutMs);

	void SetEntered();

private:
    Mutex *m_parent;
    bool m_entered;
};

EQUIS_LEAVE_NS1(equis);

#define IN_EQUIS_WIN32_MUTEX_HPP
#include "Mutex.inl"
#undef IN_EQUIS_WIN32_MUTEX_HPP

#endif /* EQUIS_WIN32_MUTEX_HPP */
