#ifndef EQUIS_WIN32_COMMON_HPP
#define EQUIS_WIN32_COMMON_HPP

/* Include functionality from Windows 2000 and later. */
#define WINVER 0x0500
#define _WIN32_WINNT 0x0500

/* Explicitly disable oldnames.lib to prevent build errors. */
#pragma comment(linker, "/nodefaultlib:oldnames.lib")

/* Suppress Microsoft's warnings for reams of standard functions. */
#pragma warning ( disable : 4995 )
#pragma warning ( disable : 4996 )

/* Disable warnings; these do not always seem to take effect. */

#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#endif /* _CRT_SECURE_NO_WARNINGS */

#ifndef _SCL_SECURE_NO_WARNINGS
#define _SCL_SECURE_NO_WARNINGS
#endif /* _SCL_SECURE_NO_WARNINGS */

/* Remove some macro pollution. */
#define NOMINMAX 1

/* Primary Windows header. */
#include <windows.h>

/* Additional Microsoft headers. */
#include <tchar.h>
#include <crtdbg.h>
#include <d3d9.h>
#include <dshow.h>
#include <wmsdkidl.h>

/* Equis C++ utility classes for Win32. */
#include "BaseUnknown.hpp"
#include "ComPtr.hpp"
#include "MediaType.hpp"
#include "Mutex.hpp"

#endif /* EQUIS_WIN32_COMMON_HPP */