using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Demos.Rocks
{
    public class Particle
    {
        private String text = null;

        private Vector2 position = Vector2.Zero;
        private Vector2 velocity = Vector2.Zero;
        private Vector4 startColor = Vector4.One;
        private Vector4 endColor = Vector4.Zero;
        private float startScale = 1.0f;
        private float endScale = 0.5f;
        private float lifetime = float.PositiveInfinity;
        private float ellapsed = 0.0f;
        private Vector2 origin = new Vector2(0.5f, 0.5f);

        public String Text
        {
            get
            {
                return text;
            }
            set
            {
                text = value;
            }
        }

        public Vector2 Position
        {
            get
            {
                return position;
            }
            set
            {
                position = value;
            }
        }

        public Vector2 Velocity
        {
            get
            {
                return velocity;
            }
            set
            {
                velocity = value;
            }
        }

        public Vector4 StartColor
        {
            get
            {
                return startColor;
            }
            set
            {
                startColor = value;
            }
        }

        public Vector4 EndColor
        {
            get
            {
                return endColor;
            }
            set
            {
                endColor = value;
            }
        }

        public float StartScale
        {
            get
            {
                return startScale;
            }
            set
            {
                startScale = value;
            }
        }

        public float EndScale
        {
            get
            {
                return endScale;
            }
            set
            {
                endScale = value;
            }
        }

        public float Lifetime
        {
            get
            {
                return lifetime;
            }
            set
            {
                lifetime = value;
            }
        }

        public float Ellapsed
        {
            get
            {
                return ellapsed;
            }
            set
            {
                ellapsed = value;
            }
        }

        public Vector2 Origin
        {
            get
            {
                return origin;
            }
            set
            {
                origin = value;
            }
        }
    }
}
