#include "touch.h"

#include "blob_detect.hpp"
#include "blob_track.hpp"
#include "calibration.hpp"

struct ETSurface {
	ETSurface() :
		video(NULL), close_video(0),
		noise_filter(0), background_drift(0), background_threshold(0),
		pixel_threshold(0), touch_threshold(0),
		sticky_press(0), sticky_release(0),
		frame_index(0),
		background_mode(2), background_start(0), background_length(10),
		noise_mode(2)
	{}

	EVInput* video;
	int close_video;

	int noise_filter;
	float background_drift;
	float background_threshold;
	float pixel_threshold;
	float touch_threshold;
	int sticky_press;
	int sticky_release;

	int background_mode;
	int background_start;
	int background_length;
	int noise_mode;

	int frame_index;

	EVFormat process_format;
	array2<uint16> converted;
	array2<uint16> temp;
	array2<uint16> filtered;
	array2<uint16> marked;
	array2<uint16> background;

    BlobDetector detect;
    BlobTracker track;
	Calibration calib;

	void process(EVInputFrame* frame);
};
