#ifndef EQUIS_TOUCH_CALIBRATION_HPP
#define EQUIS_TOUCH_CALIBRATION_HPP

#include "blob.hpp"

EQUIS_USING_NS1(equis);

class Calibration {
public:
	Calibration();

	void clear();
	bool update(const array<vec2f>& expected, const array<vec2f>& detected);

	vec2f transform(vec2f src);
	void transform(array<vec2f>& dst, const array<vec2f>& src);

	void transform(array<Blob>& blobs);

private:
	void load();
	void save();

	array2<vec2f> m_table;
};

#endif /* EQUIS_TOUCH_CALIBRATION_HPP */