#ifndef EQUIS_STATS_HH
#define EQUIS_STATS_HH

#include <queue>

//EQUIS_ENTER_NS1(equis);

class FrameStats {
public:
    FrameStats();
    ~FrameStats();

    void SetWindow(size_t frames);
    size_t GetWindow() const;
    
    void EnterFrame();
    void AddSample(double value);
    void LeaveFrame();
    
    void RemoveSample(double value);
    
    long GetCount() const;
    double GetMean() const;
    double GetStdDev() const;

    void WithoutSample(double value, double& mean, double& stddev);

private:
    size_t m_window;
    long m_count;
    double m_mean;
    double m_dev;

    struct Frame {
        long count;
        double sum;
        double dev;

        Frame();
    };
	std::queue<Frame> m_past;
    Frame* m_curr;
};

//EQUIS_LEAVE_NS1(equis);

#endif
