#ifndef EQUIS_VIDEO_DSHOW_DSINPUTFRAME_HPP
#define EQUIS_VIDEO_DSHOW_DSINPUTFRAME_HPP

#include "video/input_spi.h"

class DSInput;

class DSInputFrame : public EVInputFrame {
	EQUIS_NO_COPY(DSInputFrame);
public:
	DSInputFrame(DSInput* origin);
	~DSInputFrame();

	HRESULT SetFormat(const EVFormat* format);
	HRESULT SetSample(const AM_MEDIA_TYPE* type, IMediaSample* sample);

	const EVFormat* Format() const;
	long Size() const;
	void* Pointer();

	DSInputFrame* next;

private:
	EVFormat m_format;
	ComPtr<IMediaSample> m_sample;
	equis::array<char> m_buffer;
};

#endif /* EQUIS_VIDEO_DSHOW_DSINPUTFRAME_HPP */