#ifndef EQUIS_VIDEO_DSHOW_DSINPUTSINK_HPP
#define EQUIS_VIDEO_DSHOW_DSINPUTSINK_HPP

#include "Utility/BaseSink.hpp"
#include "Utility/MediaType.hpp"
#include "DSInput.hpp"
#include "DSInputFrame.hpp"

class DSInputSink : public BaseSink {
public:
	DSInputSink(DSInput* parent, HRESULT& res);
	virtual ~DSInputSink();

	HRESULT SetDesired(const EVFormat* format, const AM_MEDIA_TYPE* type);
	HRESULT SetCallback(EVICallbackProc callback, void* user);
	HRESULT PushUnusedFrame(DSInputFrame* frame);
	HRESULT ReadFrame(DWORD timeout, DSInputFrame** frame);

    STDMETHOD(ChangingConnectionType)(const AM_MEDIA_TYPE* type);
    STDMETHOD(QueryAccept)(const AM_MEDIA_TYPE *type);
    STDMETHOD(EnumMediaTypes)(IEnumMediaTypes **types);
    STDMETHOD(Receive)(IMediaSample *sample);

private:
	DSInput* m_parent;

	EVFormat m_desired_format;
	MediaType m_desired_type;
	MediaType m_actual_type;

	HANDLE m_frame_event;
	DSInputFrame* m_frame;

	DSInputFrame* m_unused;

	EVICallbackProc m_callback;
	void* m_callback_user;
};

#endif /* EQUIS_VIDEO_DSHOW_DSINPUTSINK_HPP */