#pragma once

#include "MediaType.hpp"

class ArrayEnumMediaTypes : public equis::BaseUnknown, public IEnumMediaTypes
{
    EQUIS_NO_COPY(ArrayEnumMediaTypes)
    BASEUNKNOWN_DECLARE(BaseUnknown)

public:
    ArrayEnumMediaTypes(AM_MEDIA_TYPE* types, ULONG length);
    virtual ~ArrayEnumMediaTypes();

    // IEnumMediaTypes
    STDMETHOD(Next)(ULONG length, AM_MEDIA_TYPE** types, ULONG *used);
    STDMETHOD(Skip)(ULONG length);
    STDMETHOD(Reset)(VOID);
    STDMETHOD(Clone)(IEnumMediaTypes **types);

private:
    AM_MEDIA_TYPE* m_types;
    ULONG m_length;
    ULONG m_index;
};

#define IN_DSHOW_ARRAYENUMMEDIATYPES_HPP
#include "ArrayEnumMediaTypes.inl"
#undef IN_DSHOW_ARRAYENUMMEDIATYPES_HPP
