#pragma once

class EnumVideoCaptures : public equis::BaseUnknown
{
    EQUIS_NO_COPY(EnumVideoCaptures);
    BASEUNKNOWN_DECLARE(BaseUnknown);

public:
    EnumVideoCaptures(HRESULT &res);
    virtual ~EnumVideoCaptures();

    // IVideoCaptureEnum
    STDMETHOD(Next)(VOID);

    STDMETHOD(GetName)(LPCWSTR* result);
    STDMETHOD(GetPath)(LPCWSTR* result);

    STDMETHOD(BindToObject)(REFIID iid, void** object);
    static HRESULT BindPathToObject(LPCWSTR path, REFIID iid, void** object);

private:
    ComPtr<IEnumMoniker> m_source;
    ComPtr<IMoniker> m_current;
    ComPtr<IPropertyBag> m_properties;

    VARIANT m_current_name;
    VARIANT m_current_path;

	char m_index_buffer[16];
};

#define IN_DSHOW_ENUMVIDEOCAPTURES_HPP
#include "EnumVideoCaptures.inl"
#undef IN_DSHOW_ENUMVIDEOCAPTURES_HPP
