#ifndef IN_DSHOW_MEDIATYPE_HPP
#error This file must be included via "DShow/MediaType.hpp"
#endif

inline
MediaType::MediaType() {
    InitMediaType(&m_value);
}

inline
MediaType::MediaType(const MediaType& source) {
    CopyMediaType(&m_value, source.ptr());
}

inline
MediaType::MediaType(const AM_MEDIA_TYPE* source) {
    CopyMediaType(&m_value, source);
}

inline
MediaType::~MediaType() {
    ClearMediaType(&m_value);
}

inline MediaType&
MediaType::operator = (const MediaType& source) {
    ClearMediaType(&m_value);
    CopyMediaType(&m_value, source.ptr());
    return *this;
}

inline MediaType&
MediaType::operator = (const AM_MEDIA_TYPE* source) {
    ClearMediaType(&m_value);
    CopyMediaType(&m_value, source);
    return *this;
}

inline AM_MEDIA_TYPE*
MediaType::ptr() {
    return &m_value;
}

inline const AM_MEDIA_TYPE*
MediaType::ptr() const {
    return &m_value;
}

inline AM_MEDIA_TYPE*
MediaType::operator -> () {
    return ptr();
}

inline const AM_MEDIA_TYPE*
MediaType::operator -> () const {
    return ptr();
}

inline void
MediaType::clear() {
    ClearMediaType(&m_value);
}
