#include "common.hpp"
#include "format.h"

long evfSize(const EVFormat* format) {
	if (!format) return -1;
	return evfStride(format) * format->height;
}

long evfStride(const EVFormat* format) {
	if (format) {
		switch (format->types) {
			case EVF_TYPE_A8R8G8B8: return 4 * format->width;
			case EVF_TYPE_Y16: return 2 * format->width;
			case EVF_TYPE_Y8: return 1 * format->width;
		}
	}
	return -1;
}
