#pragma once

#include "video/format.h"

EQUIS_ENTER_NS3(Equis,Xna,Input);

/// <summary>
/// Describes the uncompressed format of a video stream.
/// </summary>
[System::Serializable]
public ref struct VideoFormat
{
public:
	VideoFormat(SurfaceFormat format, int width, int height, LONGLONG frameInterval);

	PROPERTY_RO(SurfaceFormat, Format);
	PROPERTY_RO(int, Width);
	PROPERTY_RO(int, Height);
	PROPERTY_RO(LONGLONG, FrameInterval);

	PROPERTY_RO(float, FramesPerSecond);

	static VideoFormat ^FromNative(EVFormat *native);
	void ToNative(EVFormat *native);

	virtual String ^ToString() override;

private:
	SurfaceFormat m_format;
	int m_width;
	int m_height;
	LONGLONG m_frameInterval;
};

EQUIS_LEAVE_NS3(Equis,Xna,Input);
